package de.thpeetz.kontor.comics.views;

import java.util.List;

import com.vaadin.flow.component.ComponentEvent;
import com.vaadin.flow.component.ComponentEventListener;
import com.vaadin.flow.component.Key;
import com.vaadin.flow.component.button.Button;
import com.vaadin.flow.component.button.ButtonVariant;
import com.vaadin.flow.component.combobox.ComboBox;
import com.vaadin.flow.component.formlayout.FormLayout;
import com.vaadin.flow.component.orderedlayout.HorizontalLayout;
import com.vaadin.flow.component.textfield.TextField;
import com.vaadin.flow.data.binder.BeanValidationBinder;
import com.vaadin.flow.data.binder.Binder;

import de.thpeetz.kontor.comics.data.Comic;
import de.thpeetz.kontor.comics.data.StoryArc;
import de.thpeetz.kontor.comics.data.Volume;

public class VolumeForm extends FormLayout {

    ComboBox<Comic> comic = new ComboBox<>("Comic");
    public TextField name = new TextField("Name");

    Button save = new Button("Save");
    Button delete = new Button("Delete");
    Button close = new Button("Cancel");

    Binder<Volume> binder = new BeanValidationBinder<>(Volume.class);

    public VolumeForm(List<Comic> comics) {
        addClassName("volume-form");
        binder.bindInstanceFields(this);

        comic.setItems(comics);
        comic.setItemLabelGenerator(Comic::getTitle);
        add(comic, name, createButtonsLayout());
    }

    private HorizontalLayout createButtonsLayout() {
        save.addThemeVariants(ButtonVariant.LUMO_PRIMARY);
        delete.addThemeVariants(ButtonVariant.LUMO_ERROR);
        close.addThemeVariants(ButtonVariant.LUMO_TERTIARY);

        save.addClickShortcut(Key.ENTER);
        close.addClickShortcut(Key.ESCAPE);

        save.addClickListener(event -> validateAndSave());
        delete.addClickListener(event -> fireEvent(new DeleteEvent(this, binder.getBean())));
        close.addClickListener(event -> fireEvent(new CloseEvent(this)));

        binder.addStatusChangeListener(e -> save.setEnabled(binder.isValid()));
        return new HorizontalLayout(save, delete, close);
    }

    private void validateAndSave() {
        if (binder.isValid()) {
            fireEvent(new SaveEvent(this, binder.getBean()));
        }
    }

    public void setVolume(Volume volume) {
        binder.setBean(volume);
    }

    public abstract static class VolumeFormEvent extends ComponentEvent<VolumeForm> {
        private Volume volume;

        protected VolumeFormEvent(VolumeForm source, Volume volume) {
            super(source, false);
            this.volume = volume;
        }

        public Volume getVolume() {
            return volume;
        }
    }

    public static class SaveEvent extends VolumeFormEvent {
        SaveEvent(VolumeForm source, Volume volume) {
            super(source, volume);
        }
    }

    public static class DeleteEvent extends VolumeFormEvent {
        DeleteEvent(VolumeForm source, Volume volume) {
            super(source, volume);
        }
    }

    public static class CloseEvent extends VolumeFormEvent {
        CloseEvent(VolumeForm source) {
            super(source, null);
        }
    }

    public void addDeleteListener(ComponentEventListener<DeleteEvent> listener) {
        addListener(DeleteEvent.class, listener);
    }

    public void addSaveListener(ComponentEventListener<SaveEvent> listener) {
        addListener(SaveEvent.class, listener);
    }

    public void addCloseListener(ComponentEventListener<CloseEvent> listener) {
        addListener(CloseEvent.class, listener);
    }
}
